/* 
 *  Code largement inspire du site 
 *  http://www.codeproject.com/KB/recipes/sseintro.aspx
 * 
 */
#include <stdlib.h>
#include <stdio.h>
#include <math.h>
#include "size.h"

void computeResult(
          float* pArray1,                   // [in] first source array
          float* pArray2,                   // [in] second source array
          float* pResult,                   // [out] result array
          int nSize)                        // [in] size of all arrays

{
  int i;

  float* pSource1 = pArray1;
  float* pSource2 = pArray2;
  float* pDest = pResult;

  for ( i = 0; i < nSize; i++ ) {
    *pDest = (float)sqrt((*pSource1) * (*pSource1) + (*pSource2)
			 * (*pSource2)) + 0.5f;

    pSource1++;
    pSource2++;
    pDest++;
  }
}

int main(int argc, char *argv[]) {
  float pArray1[SIZE];
  float pArray2[SIZE];
  float pResult[SIZE];
  int i;

  printf("Debut des calculs...\n");
  printf("\tpArray1 = %p\n\tpArray2 = %p\n\tpResult = %p\n",
	 pArray1, pArray2, pResult);
  for (i=NB_TIMES; i>0; i--) {
    computeResult(pArray1, pArray2, pResult, SIZE);
  }
  printf("...Fin des calculs\n");

  return EXIT_SUCCESS;
}
